package com.nisum.example.publisher;

import com.nisum.example.subscriber.MySubscriber;
import org.reactivestreams.Subscriber;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.util.Arrays;
import java.util.Optional;

public class PublisherTest {

    public static void main(String[] args) {

        /*Flux object creation from just()*/
        //Flux<String> stringFlux=Flux.just("SAM","KHAN","SYED");
        //stringFlux.subscribe(new MySubscriber());

        /*Flux object creation from fromArray()*/
        // Flux<String> fluxArray= Flux.fromArray(new String[]{"SAI","KIRAN","RAJU"});
        // fluxArray.subscribe(new MySubscriber());

        /*Flux Object creation using fromIterable*/
        //Flux<String> stringFlux=  Flux.fromIterable(Arrays.asList("Hi","Hello"));
        //  stringFlux.subscribe(new MySubscriber());

        /*Flux object creation using range()*/
        // Flux<Integer> integerFlux=Flux.range(1,20);
        //  integerFlux.subscribe(new MySubscriber());

        /*Flux object creation using fromStream()*/
        // Flux<Integer> integerFlux= Flux.fromStream(Arrays.asList(1,2,3).stream());
        // integerFlux.subscribe(new MySubscriber());
//=======================================================================

        /*Mono object creation using just()*/
        //  Mono<Integer> integerMono= Mono.just(1);
        //  integerMono.subscribe(new MySubscriber());

        /*Mono instance using justorEmpty()*/
       // Mono<Integer> integerMono=Mono.justOrEmpty(1);
        //integerMono.subscribe(new MySubscriber());

        /*Mono instance with empty()*/
        //Mono<Void> voidMono=Mono.empty();
        //voidMono.subscribe();

        /*Mono instance justorEmpty*/
        Mono.justOrEmpty(Optional.of(2)).subscribe(new MySubscriber());


    }
}