package com.nisum.example.subscriber;

import org.reactivestreams.Subscriber;
import org.reactivestreams.Subscription;

public class MySubscriber implements Subscriber<Integer> {
    @Override
    public void onSubscribe(Subscription s) {
        s.request(10);
        System.out.println("----in onSubscribe()----------"+s);
    }

    @Override
    public void onNext(Integer integer) {
        System.out.println("--------in onNext()---------"+integer);
    }

    @Override
    public void onError(Throwable t) {
        System.out.println("------in onError-------"+t.getMessage());
    }

    @Override
    public void onComplete() {
        System.out.println("------------in onComplete()---------");
    }
}
